/**
 * Copyright (c) 2010-2012 EBMWebsourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.commons.log;

import java.util.ArrayList;
import java.util.List;

/**
 * Class allowing to define specific <Level> to Petals in addition to JDK
 * logging levels.
 * 
 * @author Christophe DENEUX - Linagora
 * 
 */
public final class Level extends java.util.logging.Level {

    private static final long serialVersionUID = 7069488588928445758L;

    /**
     * Logging Level to trace steps of a service orchestration
     */
    public static final java.util.logging.Level MONIT = new Level("MONIT", 600);

    /**
     * Name of supported logging levels.
     */
    public final static List<java.util.logging.Level> SUPPORTED_LEVELS = new ArrayList<java.util.logging.Level>();

    static {
        Level.SUPPORTED_LEVELS.add(OFF);
        Level.SUPPORTED_LEVELS.add(SEVERE);
        Level.SUPPORTED_LEVELS.add(WARNING);
        Level.SUPPORTED_LEVELS.add(INFO);
        Level.SUPPORTED_LEVELS.add(CONFIG);
        Level.SUPPORTED_LEVELS.add(MONIT);
        Level.SUPPORTED_LEVELS.add(FINE);
        Level.SUPPORTED_LEVELS.add(FINER);
        Level.SUPPORTED_LEVELS.add(FINEST);
        Level.SUPPORTED_LEVELS.add(ALL);
    }

    protected Level(String name, int value) {
        super(name, value);
    }

    /**
     * This empty method must be called before any use of a custom Level. Custom
     * Level constructor add custom Levels to known Levels registered in
     * {@link java.util.logging.Level} class.
     */
    public static void initialize() {
        // NOP
    }
}